#!/bin/sh
# chemin_noeud_chiffre.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Andr Connes <andre.connes@toulouse.iufm.fr>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : chemin_noeud_chiffre.tcl
#  Author  : Andr Connes <andre.connes@toulouse.iufm.fr>
#  Modifier:
#  Date    : 19/05/2004
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version    $Id: chemin_noeud_chiffre.tcl,v 1.10 2004/09/15 07:20:31 abuledu_andre Exp $
#  @author     Andr Connes
#  @modifier
#  @project    Le terrier
#  @copyright  Andr Connes
#
#***********************************************************************
global sysFont glob  categorie

set categorie "noeud_chiffre"


source chemin.conf
source msg.tcl
source fonts.tcl
source aider.tcl
source eval.tcl

#wm resizable . 0 0
. configure -background blue
wm geometry . +0+0
wm title . "[mc {Chiffre}]"

  #
  # langue par dfaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]



################################################
# les rpertoires des exercices peuvent tre : #
# - textes                                     #
# - images                                     #
# - sons                                       #
# - vidos                                     #
# - etc.                                       #
# donc 2 procdures  adapter au cas par cas ! #
################################################
proc init_dir_exos {} {
  global glob
  catch {set f [open [file join $glob(home_reglages) dir_exos.conf] "r"]}
  set glob(dir_exos) [gets $f]
  close $f
  if { $glob(dir_exos) == "Commun" } {
    set glob(repert) [file join grilles]
  } else {
    set glob(repert) [file join $glob(home_chemin) grilles]
  }
}

# changer le rpertoire de travail
proc change_dir_exos {} {
  global glob dir_exos
  catch {set f [open [file join $glob(home_reglages) dir_exos.conf] "w"]}
  puts $f $dir_exos
  close $f
  if { $glob(dir_exos) == "Commun" } {
    set glob(repert) [file join grilles]
  } else {
    set glob(repert) [file join $glob(home_chemin) grilles]
  }

  main_loop
}
proc set_lang {lang} {
  global env glob
  set env(LANG) $lang
  catch {set f [open [file join $glob(home_reglages) lang.conf] "w"]}
  puts $f [file rootname [file tail $lang]]
  close $f

  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

  main_loop
}

proc lanceappli {appli niveau} {
        global glob
        set appli [file join $appli]
        exec $glob(wish) $appli $niveau &
}

proc verifier_noeud_suivant {fc x y} {
  global fb glob
  set j [expr int(([$fc canvasx $x]+$glob(wlen)/2-$glob(org)-1) / $glob(wlen))]
  set i [expr int(([$fc canvasy $y]+$glob(hlen)/2-$glob(org)-1) / $glob(hlen))]
  set n [expr $glob(case_actuelle) + $glob(chiffre)]
  if { $i == [lindex $glob(trac) [expr 2*$n]] && \
       $j == [lindex $glob(trac) [expr 2*$n+1]] } {
    set glob(case_actuelle) $n
    $fc create oval \
        [expr $glob(org) + $j*$glob(wlen) +1 -9] [expr $glob(org) + $i*$glob(hlen) +1 -9] \
        [expr $glob(org) + $j*$glob(wlen) +1 +9] [expr $glob(org) + $i*$glob(hlen) +1 +9] \
        -fill green -width 1
    set glob($i,$j) green
    # vrifier si termin
    if { [expr 2*$glob(case_actuelle)+2] >= [llength $glob(trac)] } {
      #
      # pour viter les erreurs en cliquant n'importe o
      #
      for {set i 0} {$i <= $glob(nbrow)} {incr i 1} {
        for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
          $fc bind oval($i,$j) <1> {}
        }
      }
      sauver_trace_parcours
      $fb.consigne configure -text [mc Bravo] -bg pink
      button $fb.autre \
        -image [image create photo -file [file join sysdata fdroite.gif]] \
        -borderwidth 2 -bg green \
        -command main_loop
      grid $fb.autre -row 0 -column 0
      $fc create image [expr int($glob(width)/2)] [expr int($glob(height)/2)]\
        -image [image create photo -file [file join sysdata bien.gif]]
      button $fb.quitter \
        -image [image create photo -file [file join sysdata quitter_minus.gif]] \
        -borderwidth 2 -bg green \
        -command exit
      grid $fb.quitter -row 0 -column 1
    } else {
      set glob(chiffre) [hasard]
      $fb.chiffre configure \
        -image [image create photo \
         -file [file join sysdata $glob(chiffre).png]] \
        -borderwidth 2 -bg blue
    }
  } else {
    $fc create oval \
        [expr $glob(org) + $j*$glob(wlen) +1 -9] [expr $glob(org) + $i*$glob(hlen) +1 -9] \
        [expr $glob(org) + $j*$glob(wlen) +1 +9] [expr $glob(org) + $i*$glob(hlen) +1 +9] \
        -fill red -width 1
    after 100 {
        set attente_erreur non
    }
    vwait attente_erreur
    $fc create oval \
        [expr $glob(org) + $j*$glob(wlen) +1 -9] [expr $glob(org) + $i*$glob(hlen) +1 -9] \
        [expr $glob(org) + $j*$glob(wlen) +1 +9] [expr $glob(org) + $i*$glob(hlen) +1 +9] \
        -fill $glob($i,$j) -width 1 -tag oval($i,$j)
    incr glob(nberreurs)
  }
} ;# verifier_noeud_suivant


proc hasard {} {
  global glob
  # attention : ne pas dpasser les limites du chemin
  # r = random 1..9
  set r [ expr int(rand()*9) + 1 ]
  # b = distance au but
  set b [ expr int([llength $glob(trac)]/2) - $glob(case_actuelle) - 1]
  if { $b > $r } {
    return $r
  } else {
    return $b
  }
}

##########################################################################
#
  proc open_and_chiffre { } {
#
##########################################################################
  global fc fb glob
  #
  # ouvrir le fichier des cases du chemin
  #
  set tchemin {
        {{Tous les fichiers} *}
  }
  set fname [tk_getOpenFile -title [mc Slection] \
        -initialdir [file join $glob(repert)] \
        -filetypes $tchemin]
  set glob(trace_fname) [file tail $fname]
  catch {set f [open $fname "r"]}
  catch {set glob(trac) [gets $f]}
  if {[catch {close $f} r]} {
        exit
  }
  #
  # on cre la grille (ATTENTION : i=ligne et j=colonne)
  #
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
    for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
      $fc create rect [expr $glob(org) + $j*$glob(wlen) +1] [expr $glob(org) + $i*$glob(hlen) +1] \
        [expr $glob(org) + ($j+1)*$glob(wlen) +1] [expr $glob(org) + ($i+1)*$glob(hlen) +1] \
        -fill #00ffC0 -width 1
    }
  }
  #
  # on cre les noeuds
  #
  for {set i 0} {$i <= $glob(nbrow)} {incr i 1} {
    for {set j 0} {$j <= $glob(nbcol)} {incr j 1} {
      $fc create oval \
        [expr $glob(org) + $j*$glob(wlen) +1 -9] [expr $glob(org) + $i*$glob(hlen) +1 -9] \
        [expr $glob(org) + $j*$glob(wlen) +1 +9] [expr $glob(org) + $i*$glob(hlen) +1 +9] \
        -fill #00ffD0 -width 1 \
        -tag oval($i,$j)
      set glob($i,$j) #00ffD0
      $fc bind oval($i,$j) <1> {verifier_noeud_suivant $fc %x %y}
    }
  }
  #
  # afficher les noeuds du chemin
  #
  for { set n 1 } { [expr 2*$n] < [llength $glob(trac)] } { incr n } {
    set yn [lindex $glob(trac) [expr 2*$n]]
    set xn [lindex $glob(trac) [expr 2*$n+1]]
    $fc create oval \
        [expr $glob(org) + $xn*$glob(wlen) +1 -9] [expr $glob(org) + $yn*$glob(hlen) +1 -9] \
        [expr $glob(org) + $xn*$glob(wlen) +1 +9] [expr $glob(org) + $yn*$glob(hlen) +1 +9] \
        -fill yellow -width 1 \
        -tag oval($yn,$xn)
    set glob($yn,$xn) yellow
    $fc bind oval($yn,$xn) <1> {verifier_noeud_suivant $fc %x %y}
  }
  #
  # crer le canvas pour le codage
  #
  set fb .frame.b
  canvas $fb -bg blue -highlightbackground blue
  pack $fb -expand true

  label $fb.consigne \
        -text [mc {cliquer_case}] -bg blue
  grid $fb.consigne -row 0 -column 4
  #
  # placer le chiffre en bas
  #
  set glob(case_actuelle) 0
  set glob(chiffre) [ hasard ]
  label $fb.chiffre \
        -image [image create photo \
         -file [file join sysdata $glob(chiffre).png]] \
        -borderwidth 2 -bg blue
  grid $fb.chiffre -row 1 -column 6
  #
  # placer le noeud de dpart
  #
  set yn [lindex $glob(trac) 0]
  set xn [lindex $glob(trac) 1]
  $fc create oval \
        [expr $glob(org) + $xn*$glob(wlen) +1 -9] [expr $glob(org) + $yn*$glob(hlen) +1 -9] \
        [expr $glob(org) + $xn*$glob(wlen) +1 +9] [expr $glob(org) + $yn*$glob(hlen) +1 +9] \
        -fill green -width 1
  set glob($yn,$xn) green
  #
  # on passe la main  l'lve
  #
  set glob(nberreurs) 0
  # top dpart
#  if { $glob(platform) == "unix" } {
    set glob(heure_debut) [clock clicks -milliseconds]
#  } else {
#    set glob(heure_debut) 0
#  }

} ;# open_and_chiffre

###########################################################################################""
proc main_loop {} {
  global fc sysFont glob

  #########################
  #      Barre de menus   #
  #########################

  # Creation du menu utilise comme barre de menu
  #---------------------------------------------
  catch {destroy .menu}
  catch {destroy .frame}

  menu .menu -tearoff 0

  # Creation du menu Fichier
  menu .menu.fichier -tearoff 0
  .menu add cascade -label [mc {Fichier}] -menu .menu.fichier
  .menu.fichier add command -label [mc {Autre chemin}] -command main_loop
  .menu.fichier add command -label [mc {Bilans}] -state disable -command "lanceappli bilans_chemin_cases.tcl 0"
  .menu.fichier add separator
  .menu.fichier add command -label [mc {Quitter}] -command exit

  # Creation du menu Options
  menu .menu.options -tearoff 0
  .menu add cascade -label [mc {Options}] -menu .menu.options
  .menu.options add command -label [mc {Rglages}] -state disable

  set ext .msg
  menu .menu.options.lang -tearoff 0
  .menu.options add cascade -label "[mc {Langue}]" -menu .menu.options.lang

  foreach i [glob [file join  $glob(home_msgs) *$ext]] {
    set langue [string map {.$ext ""} [file tail $i]]
    .menu.options.lang add radio -label $langue -variable langue -command "set_lang $langue"
  }

  menu .menu.options.wdir -tearoff 0
  .menu.options add cascade -label [mc {Dossier de travail}] -menu .menu.options.wdir
  .menu.options.wdir add radio -label [mc {Commun}] -variable dir_exos -value Commun -command "change_dir_exos"
# .menu.options.wdir add radio -label [mc {Classe}] -state disable -variable dir_exos -value Classe -command "change_dir_exos"
  .menu.options.wdir add radio -label [mc {Individuel}] -variable dir_exos -value Individuel -command "change_dir_exos"

  # Creation du menu Aide
  menu .menu.aide -tearoff 0
  .menu add cascade -label [mc {Aide}] -menu .menu.aide
  .menu.aide add command -label [mc {Aide}] -command aider
  .menu.aide add command -label [mc { propos ...}] -command "source apropos.tcl"

  . configure -menu .menu

  # creation du frame
  ###################
  . configure -background blue
  frame .frame -background blue -height $glob(height) -width $glob(width)
  pack .frame -side top -fill both -expand yes

  # creation du canvas
  ####################

  set fc .frame.c
  canvas $fc \
        -width [expr $glob(width)+3*$glob(org)] \
        -height [expr $glob(height)+3*$glob(org)] \
        -bg blue -highlightbackground blue
  pack $fc -expand true

  open_and_chiffre

} ;# fin de main_loop

############
# Bindings #
############

bind . <Control-q> {exit}

########################################################################
#                           programme principal                        #
########################################################################

  # Relire le nom rgl de l'utilisateur sous windows
  if {$glob(platform) == "windows"} {
    catch {set f [open [file join $glob(home_chemin) reglages trace_user] "r"]}
    gets $f glob(trace_user)
    close $f
  }
init_dir_exos
main_loop

